import { connect } from "react-redux";
import "react-responsive-carousel/lib/styles/carousel.min.css";
import { Carousel } from "react-responsive-carousel";
import { actionAddlike, backendURL } from "../../actions";
import {IoHeartOutline, IoHeartSharp} from "react-icons/io5"

const ImagesInPost = ({image}) => {
    return (
        <div>
        <img className="object-cover object-center w-full h-96 bg-slate-500" src={image.url ?`${backendURL}/${image?.url}` : ""}/>
        </div>
    )
}

const LikeButton = ({onLike, props,children}) => {
    console.log(props);
    console.log(children);
    return(
        <button className="flex items-center justify-center" onClick={()=>onLike(props)}><IoHeartOutline />{children}</button>
    )
}
{/* <button className="flex items-center justify-center"><IoHeartOutline />{findPost?.likes?.length ? findPost?.likes?.length : "0"}</button> */}

const PostItem = ({findPost}) =>{
    return(
        <div className="rounded-md  shadow-md p-3 sm:w-96 lg:w-3/6">
            <div className="flex items-center justify-between p-3">
                <div className="flex items-center space-x-2">
                    <img  src={findPost.owner?.avatar?.url ? `${backendURL}/${findPost.owner?.avatar?.url}`:""} alt="userAvatar" className="object-cover object-center w-14 h-14 rounded-full shadow-sm bg-slate-600 "/>
                    <div className="-space-y-1">
                        <h2 className="text-sm font-semibold leading-none">{findPost.owner?.nick ? findPost.owner.nick : "anon"}</h2>
                    </div>
                </div>
                
              
            </div>
                <Carousel infiniteLoop showThumbs={false} showStatus={false} showArrows={true}>
                    {findPost?.images ? findPost?.images?.map(image => <ImagesInPost image={image}/>):"No image"}
                </Carousel>
                <div className="p-3">
                    <div className="flex items-center justify-between">
                        <div className="flex items-center space-x-3">
                       <CLikeButton props={findPost?._id} children={findPost?.likes?.length ? findPost?.likes?.length : "0"}/>
                        <button className="flex items-center justify-center">Comment</button>
                        <button className="flex items-center justify-center">Direct</button>
                        </div>
                        <button className="flex items-center justify-center">Save to collection</button>
                    </div>
                </div>
                <div className="space-y-3">
                        <p className="text-sm">
                            <span className="text-base font-semibold pr-2">{findPost.owner?.nick ? findPost.owner.nick : "anon"}</span>
                            {findPost?.title} {findPost?.text}
                        </p>
                     <input type="text" placeholder="Add a comment" className="w-full py-0.5 bg-transparent border-none rounded text-sm pl-0 text-gray-400"/>   
                </div>
                
        </div>
    )
}

const CLikeButton = connect(null,{onLike: actionAddlike})(LikeButton)

const CPostItem = connect(state=>({findPost: state.promise?.findPost?.payload || {}}))(PostItem)


export default CPostItem;